widget_CtrlF/announcement_board/urls.py
from django.urls import path

from .views import (
    index, 
    AnnouncementsDetailView, 
    AnnouncementsCreateView,
    AnnouncementsUpdateView,
)

urlpatterns = [
    path('', index, name='index'),
    path('<int:pk>/details/', AnnouncementsDetailView.as_view(), name='announcement-details'),
    path('add/', AnnouncementsCreateView.as_view(), name='announcement-add'),
    path('<int:pk>/edit/', AnnouncementsUpdateView.as_view(), name='announcement-edit'),
]

app_name = 'announcement_board' 

widget_CtrlF/dashboard/urls.py
from django.urls import path

from .views import (dashboard, WidgetUserDetailView, WidgetUserCreateView, WidgetUserUpdateView)

urlpatterns = [
    path ('dashboard/', dashboard, name='dashboard'),
    path ('widgetusers/<int:pk>/details', WidgetUserDetailView.as_view(), name='widgetuser-details'),
    path ('widgetusers/add', WidgetUserCreateView.as_view(), name='widgetuser-create'),
    path ('widgetusers/<int:pk>/edit', WidgetUserUpdateView.as_view(), name='widgetuser-update')
]

app_name = "dashboard"

widget_CtrlF/forum/urls.py
from django.urls import path

from .views import index

urlpatterns = [
    path('', index, name='index'),
]

app_name = "forum"

widget_CtrlF/widget_CtrlF/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('announcement_board/', include('announcement_board.urls', namespace='announcement_board')),
    path('', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
]

widget_CtrlF/announcement_board/models.py
from django.db import models
from django.utils import timezone
from dashboard.models import WidgetUser
from django.urls import reverse


class Announcement(models.Model):
    title = models.CharField(max_length=100)
    body = models.TextField(max_length=10000)
    author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE)
    pub_datetime = models.DateTimeField(default=timezone.now, null=True, blank=True)

    def date_format(self):
        return '{}' .format(self.pub_datetime.strftime("%m/%d/%Y"))
    
    def time_format(self):
        return '{}' .format(self.pub_datetime.strftime("%H:%M %p"))
    
    def getLike(self):
        try:
            return '{}'.format(Reaction.objects.get(name="Like", announcement=self).tally)
        except:
            return '0'
    
    def getLove(self):
        try:
            return '{}'.format(Reaction.objects.get(name="Love", announcement=self).tally)
        except:
            return '0'
    
    def getAngry(self):
        try:
            return '{}'.format(Reaction.objects.get(name="Angry", announcement=self).tally)
        except:
            return '0'

    def get_absolute_url(self):
        return reverse(
            'announcement_board:announcement-details',
            kwargs={'pk': self.pk},
        )

    def __str__(self):
        return '{} by {} {} published {}, {}: {}'.format(
            self.title,
            self.author.first_name,
            self.author.last_name,
            self.pub_datetime.strftime("%m/%d/%Y"),
            self.pub_datetime.strftime("%H:%M %p"),
            self.body,
        )
    
class Reaction(models.Model):
    Like = 'Like'
    Love = 'Love'
    Angry = 'Angry'
    REACTIONS = ((Like, 'Like'), 
        (Love, 'Love'), 
        (Angry, 'Angry'))
    

    name = models.CharField(max_length=10, choices=REACTIONS, default=Like)
    tally = models.IntegerField(default = 0)
    announcement = models.ForeignKey(Announcement, on_delete = models.CASCADE)

    def __str__(self):
        return '{} reactions for {}' .format(self.name, self.announcement)

widget_CtrlF/dashboard/models.py
from django.db import models
from django.urls import reverse


class Department(models.Model):
    dept_name = models.CharField(max_length=255)
    home_unit = models.CharField(max_length=255)

    def __str__(self):
        return '{}, {}'.format(self.dept_name, self.home_unit)


class WidgetUser(models.Model):
    first_name = models.CharField(max_length=100)
    middle_name = models.CharField(max_length=100)
    last_name = models.CharField(max_length=100)
    department = models.ForeignKey(Department, on_delete=models.CASCADE)

    def __str__(self):
        return '{}, {} {}'.format(self.last_name, self.first_name, self.middle_name)    
    
    def get_absolute_url(self):
        return reverse('dashboard:widgetuser-details', kwargs={'pk': self.pk})

widget_CtrlF/forum/models.py
from django.db import models
from django.utils import timezone
from dashboard.models import WidgetUser


class ForumPost(models.Model):
    title = models.CharField(max_length=100)
    body = models.TextField()
    author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE)
    pub_datetime =  models.DateTimeField()

    def __str__(self):
        return self.title
    

class Reply(models.Model):
    forum_post = models.ForeignKey(ForumPost, on_delete=models.CASCADE, null=True)
    body = models.TextField()
    author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE) 
    pub_datetime = models.DateTimeField(default=timezone.now, null=True, blank=True) 

    def __str__(self):
        return 'Reply by {} {} posted {}'.format(
            self.author.first_name, self.author.last_name, 
            self.pub_datetime.strftime('%m/%d/%Y, %H:%M %p')
            )

widget_CtrlF/announcement_board/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView
from .models import Announcement

def index(request):
    announcement_view = "Widget's Announcement Board <br/>"
    announcements = Announcement.objects.all()
    return render(
        request, 
        'announcements/announcements.html', 
        {'announcements_list': announcements},
    )


class AnnouncementsDetailView(DetailView):
    model = Announcement
    template_name = 'announcements/announcement-details.html'
    

class AnnouncementsCreateView(CreateView):
    model = Announcement
    fields = 'title', 'body', 'author'
    template_name = 'announcements/announcement-add.html'
    

class AnnouncementsUpdateView(UpdateView):
    model = Announcement
    fields = 'title', 'body', 'author'
    template_name = 'announcements/announcement-edit.html'


    # for a in announcements:
    #     like_tally=0
    #     love_tally=0
    #     angry_tally=0
    #     for r in reactions:
    #         if r.name=="Like" and r.announcement==a:
    #             like_tally+=r.tally
    #         elif r.name=="Love" and r.announcement==a:
    #             love_tally+=r.tally
    #         elif r.name=="Angry" and r.announcement==a:
    #             angry_tally+=r.tally
    #     announcement_view +=  "<br/> {} by {} {} published {}: <br/> {} <br/> Like: {} <br/> Love: {} <br/> Angry: {} <br/>".\
    #         format(a.title,
    #         a.author.first_name,
    #         a.author.last_name,
    #         a.pub_datetime.strftime('%m/%d/%Y, %H:%M %p'),
    #         a.body,
    #         like_tally,
    #         love_tally,
    #         angry_tally)
        
    # return HttpResponse(announcement_view)

widget_CtrlF/dashboard/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import WidgetUser


def dashboard(request):
    users = WidgetUser.objects.all()
    return render(request, 'dashboard/dashboard.html', {'users': users})


class WidgetUserDetailView(DetailView):
    model = WidgetUser
    template_name = 'dashboard/widgetuser-details.html'


class WidgetUserCreateView(CreateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-add.html'


class WidgetUserUpdateView(UpdateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-edit.html'

widget_CtrlF/forum/views.py
from django.shortcuts import render
from django.http import HttpResponse

from .models import ForumPost, Reply
# Create your views here.
def index(request):
    page_content = "<p>Widget's Forum</p> Forum Posts:<br>"
    
    for post in ForumPost.objects.all():
        page_content += '{} by {} {} posted {}:<br>{}<br>'.format(
            post.title, post.author.first_name, post.author.last_name, 
            post.pub_datetime.strftime('%m/%d/%Y, %H:%M %p'), post.body
        )
        for reply in Reply.objects.all():
            if reply.forum_post.title==post.title:
                page_content += 'Reply by {} {} posted {}:<br>{}<br>'.format(
                    reply.author.first_name, reply.author.last_name, 
                    reply.pub_datetime.strftime('%m/%d/%Y, %H:%M %p'),
                    reply.body
                )
    
    return HttpResponse(page_content)

widget_CtrlF/announcement_board/templates/announcements/announcement-add.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}Add Announcement{% endblock %}

{% block heading %}
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 14px 16px;
  text-decoration: none;
}

li a:hover {
  background-color: #111;
}
</style>
</head>
<body>

<ul>
    <li><a class="active" href="/announcement_board/">Back</a></li>
    <li><a href="/dashboard/">Dashboard</a></li>
    <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<h2>Add a new announcement:</h2>
{% endblock %}

{% block content %}
<form method="POST">
    {% csrf_token %}
    <h3>
    <table>
        {{ form.as_table }}
    </table><br><br>
    </h3>  
    <p>
        <input class="button" type="submit" value="Add Announcement">
    </p>
</form>
{% endblock %}

widget_CtrlF/announcement_board/templates/announcements/announcement-details.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}{{ announcement.title }}{% endblock %}
{% block heading %}
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 14px 16px;
  text-decoration: none;
}

li a:hover {
  background-color: #111;
}
</style>
</head>
<body>

<ul>
  <li><a class="active" href="/announcement_board/">Back</a></li>
  <li><a href="/dashboard/">Dashboard</a></li>
  <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>
{% endblock %}

{% block content %}
<link href='https://fonts.googleapis.com/css?family=Dancing Script' rel='stylesheet'>
<section>
    <span>{{ announcement.title }}</span>
</section>


<h2>
    {{ announcement.title }}
</h2>

<p>
    by {{ announcement.author.first_name }} {{ announcement.author.last_name }}<br>
    {{ announcement.date_format}}, {{ announcement.time_format }}<br><br>
    {{ announcement.body }}<br>
</p>

<p>
    Like: {{ announcement.getLike }}<br>
    Love: {{ announcement.getLove }}<br>
    Angry: {{ announcement.getAngry}} <br><br>
</p>

<p>
    <a href="{% url 'announcement_board:announcement-edit' announcement.pk %}">
        <button class="btn">Edit Announcement</button>
    </a>
</p>
{% endblock %}

widget_CtrlF/announcement_board/templates/announcements/announcement-edit.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}Edit Announcement{% endblock %}

{% block heading %}
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 14px 16px;
  text-decoration: none;
}

li a:hover {
  background-color: #111;
}
</style>
</head>
<body>

<ul>
    <li><a class="active" href="/announcement_board/">Back</a></li>
    <li><a href="/dashboard/">Dashboard</a></li>
    <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<h2>Edit announcement:</h2>
{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    <h3>
    <table>
      {{ form.as_table }}
    </table><br><br>
    </h3>
    <p>
      <input class="button" type="submit" value="Save Changes to Announcement">
    </p>
  </form>
{% endblock %}

widget_CtrlF/announcement_board/templates/announcements/announcements.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %} Widget's Announcement Board {% endblock %}

{% block heading %} 
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 14px 16px;
  text-decoration: none;
}

li a:hover {
  background-color: #111;
}
</style>
</head>
<body>

<ul>
  <li><a class="active" href="/dashboard/">Dashboard</a></li>
  <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<header> 
<link href='https://fonts.googleapis.com/css?family=Dancing Script' rel='stylesheet'>
    <div class="overlay">
        <h> Welcome to Widget's Announcement Board! </h> 
    </div>
</header>
{% endblock %}

{% block content %}
<h3>Announcements: </h3>
<p>{% for a in announcements_list %}
        <a href="{% url 'announcement_board:announcement-details' a.pk %}">
            {{a.title}} by {{ a.author.first_name }} {{ a.author.last_name }}
        </a><br>
    {% endfor %}
<br>
</p>
{% endblock %}

{% block footing %}
<p>
    <a href="{% url 'announcement_board:announcement-add' %}">
        <button class="btn add">New Announcement</button>
    </a>
</p>
{% endblock %}

widget_CtrlF/dashboard/templates/dashboard/dashboard.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}Widget v2{% endblock %}

{% block heading %} 
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 10px 15px;
  text-decoration: none;
}

li a:hover {
  background-color: #57065b;
}
</style>
</head>
<body>

<ul>
  <li><a class="active" href="/announcement_board/">Announcement Board</a></li>
  <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<header> 
  <link href='https://fonts.googleapis.com/css?family=Dancing Script' rel='stylesheet'>
      <div class="overlay">
          <h> Welcome to Widget! </h> 
      </div>
</header> 
{% endblock %}

{% block content %}
<p>
    Widget Users:<br>
    {% for user in users %}
    <a href="{{ user.get_absolute_url }}">{{ user.last_name }}, {{ user.first_name }}</a><br>
    {% endfor %}
</p>
{% endblock %}

{% block footing %}
<p>
    <a href="{% url 'dashboard:widgetuser-create' %}">
        <button class="btn add">Add Widget User</button>
     </a>
</p>
{% endblock %}

widget_CtrlF/dashboard/templates/dashboard/widgetuser-add.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}Add Widget User{% endblock %}

{% block heading %} 
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 10px 15px;
  text-decoration: none;
}

li a:hover {
  background-color: #57065b;
}
</style>
</head>
<body>

<ul>
  <li><a class="active" href="/dashboard/">Back</a></li>
  <li><a href="/announcement_board/">Announcement Board</a></li>
  <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<h2> Add a new Widget User: </h2> 
{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
        <input class="submitB" type="submit" value="Add Widget User">
</form>
{% endblock %}

widget_CtrlF/dashboard/templates/dashboard/widgetuser-details.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}{{ object.last_name }}, {{ object.first_name }}{% endblock %}

{% block heading %} 
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 10px 15px;
  text-decoration: none;
}

li a:hover {
  background-color: #57065b;
}
</style>
</head>
<body>

<ul>
  <li><a class="active" href="/dashboard/">Back</a></li>
  <li><a href="/announcement_board/">Announcement Board</a></li>
  <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<link href='https://fonts.googleapis.com/css?family=Dancing Script' rel='stylesheet'>
<section>
    <span>{{ object.first_name }} {{ object.middle_name }} {{ object.last_name }}</span>
</section>
{% endblock %}

{% block content %}
<p>
    {{ object.department.dept_name }}<br>
    {{ object.department.home_unit }}<br>
</p>
{% endblock %}

{% block footing %}
    <a href="{% url 'dashboard:widgetuser-update' object.pk %}">
        <button class="btn edit">Edit Widget User</button>
    </a>
{% endblock %}

widget_CtrlF/dashboard/templates/dashboard/widgetuser-edit.html
{% extends 'base.html' %}
{% load static %}

{% block page-title %}Edit Widget User{% endblock %}

{% block heading %} 
<!DOCTYPE html>
<html>
<head>
<style>
ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  overflow: hidden;
  background-color: #333;
}

li {
  float: left;
}

li a {
  display: block;
  color: white;
  text-align: center;
  padding: 10px 15px;
  text-decoration: none;
}

li a:hover {
  background-color: #57065b;
}
</style>
</head>
<body>

<ul>
  <li><a class="active" href="/dashboard/">Back</a></li>
  <li><a href="/announcement_board/">Announcement Board</a></li>
  <li><a href="/forum/">Forum</a></li>
</ul>
</body>
</html>

<h2> Edit Widget User: </h2> 
{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
        <input class="submitB" type="submit" value="Save Changes to Widget User">
</form>
{% endblock %}

widget_CtrlF/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <title>{% block page-title %}{% endblock %}</title>
</head>

<body>
    <div id="heading">
        {% block heading %}
        {% endblock %}
    </div>
    <div id="content">
        {% block content %}
        {% endblock %}
    </div>
    <div id="footing">
        {% block footing %}
        {% endblock %}
    </div>
</body>

</html>